
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ReelsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const reels = await db.reels.create(
            {
                id: data.id || undefined,
        
        caption: data.caption
        ||
        null
            ,
            
        audio_title: data.audio_title
        ||
        null
            ,
            
        audio_artist: data.audio_artist
        ||
        null
            ,
            
        duration_seconds: data.duration_seconds
        ||
        null
            ,
            
        is_archived: data.is_archived
        ||
        false
        
            ,
            
        published_at: data.published_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await reels.setAuthor( data.author || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.reels.getTableName(),
                belongsToColumn: 'video',
                belongsToId: reels.id,
            },
            data.video,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.reels.getTableName(),
                belongsToColumn: 'cover_image',
                belongsToId: reels.id,
            },
            data.cover_image,
            options,
        );
        

        return reels;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const reelsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                caption: item.caption
            ||
            null
            ,
            
                audio_title: item.audio_title
            ||
            null
            ,
            
                audio_artist: item.audio_artist
            ||
            null
            ,
            
                duration_seconds: item.duration_seconds
            ||
            null
            ,
            
                is_archived: item.is_archived
            ||
            false
        
            ,
            
                published_at: item.published_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const reels = await db.reels.bulkCreate(reelsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < reels.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.reels.getTableName(),
                    belongsToColumn: 'video',
                    belongsToId: reels[i].id,
                },
                data[i].video,
                options,
            );
        }
        
        for (let i = 0; i < reels.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.reels.getTableName(),
                    belongsToColumn: 'cover_image',
                    belongsToId: reels[i].id,
                },
                data[i].cover_image,
                options,
            );
        }
        

        return reels;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const reels = await db.reels.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.caption !== undefined) updatePayload.caption = data.caption;
        
        
        if (data.audio_title !== undefined) updatePayload.audio_title = data.audio_title;
        
        
        if (data.audio_artist !== undefined) updatePayload.audio_artist = data.audio_artist;
        
        
        if (data.duration_seconds !== undefined) updatePayload.duration_seconds = data.duration_seconds;
        
        
        if (data.is_archived !== undefined) updatePayload.is_archived = data.is_archived;
        
        
        if (data.published_at !== undefined) updatePayload.published_at = data.published_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await reels.update(updatePayload, {transaction});

        
        
        if (data.author !== undefined) {
            await reels.setAuthor(
              
              data.author,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.reels.getTableName(),
                belongsToColumn: 'video',
                belongsToId: reels.id,
            },
            data.video,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.reels.getTableName(),
                belongsToColumn: 'cover_image',
                belongsToId: reels.id,
            },
            data.cover_image,
            options,
        );
        

        return reels;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const reels = await db.reels.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of reels) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of reels) {
                await record.destroy({transaction});
            }
        });


        return reels;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const reels = await db.reels.findByPk(id, options);

        await reels.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await reels.destroy({
            transaction
        });

        return reels;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const reels = await db.reels.findOne(
            { where },
            { transaction },
        );

        if (!reels) {
            return reels;
        }

        const output = reels.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.reel_reactions_reel = await reels.getReel_reactions_reel({
            transaction
        });
        
        
        output.reel_comments_reel = await reels.getReel_comments_reel({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        output.author = await reels.getAuthor({
            transaction
        });
        
        
        output.video = await reels.getVideo({
            transaction
        });
        
        
        output.cover_image = await reels.getCover_image({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'author',
        
        where: filter.author ? {
          [Op.or]: [
            { id: { [Op.in]: filter.author.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.author.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'video',
      },

      {
        model: db.file,
        as: 'cover_image',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.caption) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'reels',
                        'caption',
                        filter.caption,
                    ),
                };
            }
            
            if (filter.audio_title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'reels',
                        'audio_title',
                        filter.audio_title,
                    ),
                };
            }
            
            if (filter.audio_artist) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'reels',
                        'audio_artist',
                        filter.audio_artist,
                    ),
                };
            }
            

            
            

            
            if (filter.duration_secondsRange) {
                const [start, end] = filter.duration_secondsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    duration_seconds: {
                    ...where.duration_seconds,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    duration_seconds: {
                    ...where.duration_seconds,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.published_atRange) {
                const [start, end] = filter.published_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_archived) {
                where = {
                    ...where,
                is_archived: filter.is_archived,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.reels.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'reels',
                        'caption',
                        query,
                    ),
                ],
            };
        }

        const records = await db.reels.findAll({
            attributes: [ 'id', 'caption' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['caption', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.caption,
        }));
    }

    
};

